declare type Element = HTMLElement | null;
declare type SpmProps = {
    appType: string;
    spmPrefix?: string;
    pageSessionName?: string;
    moduleSessionName?: string;
    eventSessionName?: string;
    headerCustomPrefix?: string;
    fromApp?: string;
    onPageLoad?: (headerParams: {
        [key: string]: string;
    }) => void;
    onEventListener?: (headerParams: {
        [key: string]: string;
    }) => void;
    listenerEvents?: string[];
    isHash?: boolean;
    fromParams?: boolean;
};
export default class Spm {
    private appType;
    private pageSessionName;
    private moduleSessionName;
    private eventSessionName;
    private fromApp;
    private onPageLoad;
    private onEventListener;
    private listenerEvents;
    private isHash;
    private fromParams;
    private headerCustomPrefix;
    private spmPrefix;
    constructor(props: SpmProps);
    /**
     * 获取所属模块或者页面的spm
     * @param dom 触发事件的dom
     * @param spmType 页面、模块、事件的spm属性名
     */
    findSpm(dom: Element, spmType: string): {
        spmDom: Element;
        spmData: string;
    };
    /**
     * 获取自定义埋点数据
     * @param dom 点击的dom
     */
    getCustomSpm(dom: Element): {
        [key: string]: string;
    };
    location(prop: string): any;
    pageLoad(page: string): void;
    /**
     * 埋点初始化
     */
    init(): void;
}
export {};
