"use strict";

exports.__esModule = true;
exports.formatParams = exports.getSession = exports.setSession = void 0;

/* eslint-disable prefer-rest-params */
var newListener = new Event('history');
var _pushState = window.history.pushState;
var _replaceState = window.history.replaceState;

window.history.pushState = function () {
  _pushState.apply(history, arguments);

  if (arguments[0]) {
    window.dispatchEvent(newListener);
  }
};

window.history.replaceState = function () {
  _replaceState.apply(history, arguments);

  if (arguments[0]) {
    window.dispatchEvent(newListener);
  }
};
/**
 * session存储，如果value为空则移除这个session
 * @param key
 * @param value
 */


var setSession = function setSession(key, value) {
  if (value) {
    window.sessionStorage.setItem(key, value);
  } else {
    window.sessionStorage.removeItem(key);
  }
};
/**
 * session取值
 * @param key
 */


exports.setSession = setSession;

var getSession = function getSession(key) {
  return window.sessionStorage.getItem(key);
};

exports.getSession = getSession;

/**
 * 格式化日志接口需要的参数
 * @param data 参数
 * @param isFrom 是否需要from参数
 */
var formatParams = function formatParams(spmSelf, data, base) {
  if (base === void 0) {
    base = {};
  }

  var params = base;
  var prefix = spmSelf.headerCustomPrefix; // 拼接spm

  var headerSpm = data.app + "." + data.page;

  if (data.module) {
    headerSpm += "." + data.module;

    if (data.event) {
      headerSpm += "." + data.event;
    }
  }

  params[prefix + "spm"] = headerSpm;
  data.fromApp && (params[prefix + "from-app"] = data.fromApp); // 允许使用from参数

  if (spmSelf.fromParams) {
    data.fromPage && (params[prefix + "from-page"] = data.fromPage);
    data.fromModule && (params[prefix + "from-module"] = data.fromModule);
    data.fromEvent && (params[prefix + "from-event"] = data.fromEvent);
  }

  return params;
};

exports.formatParams = formatParams;